> ## Documentation Index
> Fetch the complete documentation index at: https://www.cometchat.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Groups With Messages

> Groups With Messages — CometChat documentation.

## Overview

The GroupsWithMessages is a [Composite Component](/ui-kit/react/v4/components-overview#composite-components) encompassing components such as [Groups](/ui-kit/react/v4/groups) and [Messages](/ui-kit/react/v4/messages). Both of these component contributes to the functionality and structure of the overall GroupsWithMessages component.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/CrArf1QwUPg5EvCC/images/2c9552a8-groups_with_messages_overview_web_screens-6639575885906978e81df0cd11d3efde.png?fit=max&auto=format&n=CrArf1QwUPg5EvCC&q=85&s=2cf8701de19fdf341941cba73ea19a8a" width="3600" height="2400" data-path="images/2c9552a8-groups_with_messages_overview_web_screens-6639575885906978e81df0cd11d3efde.png" />
</Frame>

| Components                            | Description                                                                                                                    |
| ------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------ |
| [Groups](/ui-kit/react/v4/groups)     | The `Groups` component is designed to display a list of `Groups`. This essentially represents the recent conversation history. |
| [Messages](/ui-kit/react/v4/messages) | The `Messages` component is designed to manage the messaging interaction for `Group's` conversations.                          |

## Usage

### Integration

<Tabs>
  <Tab title="GroupsWithMessagesDemo.tsx">
    ```typescript theme={null}
    import { CometChatGroupsWithMessages } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupsWithMessagesDemo = () => {
      return <CometChatGroupsWithMessages />;
    };

    export default GroupsWithMessagesDemo;
    ```
  </Tab>

  <Tab title="App.tsx">
    ```typescript theme={null}
    import GroupsWithMessagesDemo from "./GroupsWithMessagesDemo";

    export default function App() {
      return (
        <div className="App">
          <GroupsWithMessagesDemo />
        </div>
      );
    }
    ```
  </Tab>
</Tabs>

***

### Actions

[Actions](/ui-kit/react/v4/components-overview#actions) dictate how a component functions. They are divided into two types: Predefined and User-defined. You can override either type, allowing you to tailor the behavior of the component to fit your specific needs.

#### 1. onError

This action doesn't change the behavior of the component but rather listens for any errors that occur in the GroupsWithMessages component.

<Tabs>
  <Tab title="TypeScript">
    GroupsWithMessagesDemo.tsx

    ```typescript theme={null}
    import { CometChatGroupsWithMessages } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupsWithMessagesDemo = () => {
      const handleOnError = (error: CometChat.CometChatException) => {
        console.log("Your custom on error actions");
      };
      return <CometChatGroupsWithMessages onError={handleOnError} />;
    };

    export default GroupsWithMessagesDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupsWithMessagesDemo.jsx

    ```javascript theme={null}
    import { CometChatGroupsWithMessages } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupsWithMessagesDemo = () => {
      const handleOnError = (error) => {
        console.log("Your custom on error actions");
      };
      return <CometChatGroupsWithMessages onError={handleOnError} />;
    };

    export default GroupsWithMessagesDemo;
    ```
  </Tab>
</Tabs>

The child components - [Groups](/ui-kit/react/v4/groups) and [Messages](/ui-kit/react/v4/messages) - both have their own set of action events.

The Action of the components can be overridden through the use of the [Configurations](#configurations) object of its components. Here is an example code snippet.

<Tabs>
  <Tab title="TypeScript">
    GroupsWithMessagesDemo.tsx

    ```typescript theme={null}
    import {
      CometChatGroupsWithMessages,
      MessageHeaderConfiguration,
      MessagesConfiguration,
      GroupsConfiguration,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupsWithMessagesDemo = () => {
      function handleOnItemClick(group: CometChat.Group): void {
        console.log(group, "your custom on item click action");
      }
      function handleOnBack() {
        console.log("your custom on back action");
      }
      return (
        <CometChatGroupsWithMessages
          groupsConfiguration={
            new GroupsConfiguration({
              onItemClick: handleOnItemClick,
            })
          }
          messagesConfiguration={
            new MessagesConfiguration({
              messageHeaderConfiguration: new MessageHeaderConfiguration({
                onBack: handleOnBack,
              }),
            })
          }
        />
      );
    };

    export default GroupsWithMessagesDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupsWithMessagesDemo.jsx

    ```javascript theme={null}
    import {
      CometChatGroupsWithMessages,
      MessageHeaderConfiguration,
      MessagesConfiguration,
      GroupsConfiguration,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupsWithMessagesDemo = () => {
      function handleOnItemClick(group) {
        console.log(group, "your custom on item click action");
      }

      function handleOnBack() {
        console.log("your custom on back action");
      }

      return (
        <CometChatGroupsWithMessages
          groupsConfiguration={
            new GroupsConfiguration({
              onItemClick: handleOnItemClick,
            })
          }
          messagesConfiguration={
            new MessagesConfiguration({
              messageHeaderConfiguration: new MessageHeaderConfiguration({
                onBack: handleOnBack,
              }),
            })
          }
        />
      );
    };

    export default GroupsWithMessagesDemo;
    ```
  </Tab>
</Tabs>

The GroupsWithMessages component overrides several actions from its components to reach its default behavior. The list of actions overridden by GroupsWithMessages includes:

* [OnItemClick](/ui-kit/react/v4/groups#2-onitemclick) : By overriding the `OnItemClick` of the Groups Component, GroupsWithMessages achieves navigation from [Groups](/ui-kit/react/v4/groups) to [Messages](/ui-kit/react/v4/messages) component.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/L67V-UjCgqzL1qxp/images/74a441ba-groups_with_messages_onitemclick_web_screens-1d1519011941cfe7498682d4a010cbe3.png?fit=max&auto=format&n=L67V-UjCgqzL1qxp&q=85&s=6365308e1d1fd560e5d94ee375d1c646" width="3600" height="2400" data-path="images/74a441ba-groups_with_messages_onitemclick_web_screens-1d1519011941cfe7498682d4a010cbe3.png" />
</Frame>

### Filters

**Filters** allow you to customize the data displayed in a list within a Component. You can filter the list based on your specific criteria, allowing for a more customized. Filters can be applied using RequestBuilders of Chat SDK.

While the GroupsWithMessages component does not have filters, its components do, For more detail on individual filters of its component refer to [Groups Filters](/ui-kit/react/v4/groups#filters) and [Messages Filters](/ui-kit/react/v4/messages#filters).

By utilizing the [Configurations](#configurations) object of its components, you can apply filters.

In the following **example**, we are applying a filter to the Group List based on only joined groups and setting the limit to 3 using the `groupsRequestBuilder`.

<Tabs>
  <Tab title="TypeScript">
    GroupsWithMessagesDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatGroupsWithMessages,
      GroupsConfiguration,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupsWithMessagesDemo = () => {
      return (
        <CometChatGroupsWithMessages
          groupsConfiguration={
            new GroupsConfiguration({
              groupsRequestBuilder: new CometChat.GroupsRequestBuilder()
                .setLimit(3)
                .joinedOnly(true),
            })
          }
        />
      );
    };

    export default GroupsWithMessagesDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupsWithMessagesDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatGroupsWithMessages,
      GroupsConfiguration,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupsWithMessagesDemo = () => {
      return (
        <CometChatGroupsWithMessages
          groupsConfiguration={
            new GroupsConfiguration({
              groupsRequestBuilder: new CometChat.GroupsRequestBuilder()
                .setLimit(3)
                .joinedOnly(true),
            })
          }
        />
      );
    };

    export default GroupsWithMessagesDemo;
    ```
  </Tab>
</Tabs>

***

### Events

[Events](/ui-kit/react/v4/components-overview#events) are emitted by a `Component`. By using event you can extend existing functionality. Being global events, they can be applied in Multiple Locations and are capable of being Added or Removed.

The GroupsWithMessages does not produce any events but its component does.

***

## Customization

To fit your app's design requirements, you have the ability to customize the appearance of the GroupsWithMessages component. We provide exposed methods that allow you to modify the experience and behavior according to your specific needs.

### Style

Using **Style** you can **customize** the look and feel of the component in your app, These parameters typically control elements such as the **color**, **size**, **shape**, and **fonts** used within the component.

#### 1. GroupsWithMessages Style

You can set the `groupsWithMessagesStyle` to the GroupsWithMessages Component to customize the styling.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/4xujL4pc0yDqaECl/images/d362dd5c-groups_with_messages_style_web_screens-02770b145161909851c36884ae4089b6.png?fit=max&auto=format&n=4xujL4pc0yDqaECl&q=85&s=e538c842f064a683ff414966beda51cf" width="3600" height="2400" data-path="images/d362dd5c-groups_with_messages_style_web_screens-02770b145161909851c36884ae4089b6.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    GroupsWithMessagesDemo.tsx

    ```typescript theme={null}
    import {
      CometChatGroupsWithMessages,
      WithMessagesStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupsWithMessagesDemo = () => {
      const groupsWithMessagesStyle = new WithMessagesStyle({
        background: "#e2d6ff",
        messageTextColor: "#000000",
        borderRadius: "12px",
      });
      return (
        <CometChatGroupsWithMessages
          groupsWithMessagesStyle={groupsWithMessagesStyle}
        />
      );
    };

    export default GroupsWithMessagesDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupsWithMessagesDemo.jsx

    ```javascript theme={null}
    import {
      CometChatGroupsWithMessages,
      WithMessagesStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupsWithMessagesDemo = () => {
      const groupsWithMessagesStyle = new WithMessagesStyle({
        background: "#e2d6ff",
        messageTextColor: "#000000",
        borderRadius: "12px",
      });
      return (
        <CometChatGroupsWithMessages
          groupsWithMessagesStyle={groupsWithMessagesStyle}
        />
      );
    };

    export default GroupsWithMessagesDemo;
    ```
  </Tab>
</Tabs>

***

You can also customize its component styles. For more details on individual component styles, you can refer [Groups Styles](/ui-kit/react/v4/groups#1-groups-style) and [Messages Styles](/ui-kit/react/v4/messages#1-messages-style).

Styles can be applied to SubComponents using their respective [configurations](#configurations).

**Example**

<Tabs>
  <Tab title="TypeScript">
    GroupsWithMessagesDemo.tsx

    ```typescript theme={null}
    import {
      CometChatGroupsWithMessages,
      GroupsConfiguration,
      MessagesConfiguration,
      GroupsStyle,
      MessagesStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupsWithMessagesDemo = () => {
      const groupsStyle = new GroupsStyle({
        width: "100%",
        height: "100%",
        border: "1px solid #ee7752",
        background: "linear-gradient(#ee7752, #e73c7e, #23a6d5, #23d5ab)",
      });
      const messagesStyle = new MessagesStyle({
        width: "100%",
        height: "100%",
        border: "3px solid #cb1fff",
        background: "linear-gradient(#885df5, #d396ff, #e497f0, #dd20fa)",
        messageTextColor: "yellow",
      });
      return (
        <CometChatGroupsWithMessages
          groupsConfiguration={
            new GroupsConfiguration({
              groupsStyle: groupsStyle,
            })
          }
          messagesConfiguration={
            new MessagesConfiguration({
              messagesStyle: messagesStyle,
            })
          }
        />
      );
    };

    export default GroupsWithMessagesDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupsWithMessagesDemo.jsx

    ```javascript theme={null}
    import {
      CometChatGroupsWithMessages,
      GroupsConfiguration,
      MessagesConfiguration,
      GroupsStyle,
      MessagesStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupsWithMessagesDemo = () => {
      const groupsStyle = new GroupsStyle({
        width: "100%",
        height: "100%",
        border: "1px solid #ee7752",
        background: "linear-gradient(#ee7752, #e73c7e, #23a6d5, #23d5ab)",
      });
      const messagesStyle = new MessagesStyle({
        width: "100%",
        height: "100%",
        border: "3px solid #cb1fff",
        background: "linear-gradient(#885df5, #d396ff, #e497f0, #dd20fa)",
        messageTextColor: "yellow",
      });
      return (
        <CometChatGroupsWithMessages
          groupsConfiguration={
            new GroupsConfiguration({
              groupsStyle: groupsStyle,
            })
          }
          messagesConfiguration={
            new MessagesConfiguration({
              messagesStyle: messagesStyle,
            })
          }
        />
      );
    };

    export default GroupsWithMessagesDemo;
    ```
  </Tab>
</Tabs>

***

### Functionality

These are a set of **small functional customizations** that allow you to **fine-tune** the overall experience of the component. With these, you can **change text**, set **custom icons**, and toggle the **visibility** of UI elements.

you can utilize the `group` method with a [Group](/sdk/javascript/create-group) object as input to the GroupsWithMessages component. This will automatically direct you to the [Messages](/ui-kit/react/v4/messages) component for the specified `Group`.

#### 1. Group

<Tabs>
  <Tab title="TypeScript">
    GroupsWithMessagesDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupsWithMessages } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupsWithMessagesDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<
        CometChat.Group | undefined
      >();

      React.useEffect(() => {
        CometChat.getGroup("guid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      return <CometChatGroupsWithMessages group={chatGroup} />;
    };

    export default GroupsWithMessagesDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupsWithMessagesDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupsWithMessages } from "@cometchat/chat-uikit-react";
    import React, { useEffect, useState } from "react";

    const GroupsWithMessagesDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      useEffect(() => {
        CometChat.getGroup("guid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      return <CometChatGroupsWithMessages group={chatGroup} />;
    };

    export default GroupsWithMessagesDemo;
    ```
  </Tab>
</Tabs>

Below is a list of customizations along with corresponding code snippets:

| Property         | Description                                                                                                                                                      | Code                                     |
| ---------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------- | ---------------------------------------- |
| **isMobileView** | A boolean indicating if the component should render in mobile view for optimized display on mobile devices.                                                      | `isMobileView: false`                    |
| **group**        | Use the group property with a Group object as input for the GroupsWithMessages component to navigate directly to the Messages component for the specified Group. | `group={chatGroup}`                      |
| **messageText**  | It represents the textual content which will be replaced with the messages component when user clicks on a particular group chat.                                | `messageText="Your Custom Message Text"` |

***

#### Components

Nearly all functionality customizations available for a Component are also available for the composite component. Using [Configuration](#configurations), you can modify the properties of its components to suit your needs.

You can find the list of all Functionality customization of individual components in [Groups](/ui-kit/react/v4/groups#functionality) and [Messages](/ui-kit/react/v4/messages#functionality).

**Example**

<Tabs>
  <Tab title="TypeScript">
    GroupsWithMessagesDemo.tsx

    ```typescript theme={null}
    import {
      CometChatGroupsWithMessages,
      GroupsConfiguration,
      MessagesConfiguration,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupsWithMessagesDemo = () => {
      return (
        <CometChatGroupsWithMessages
          groupsConfiguration={
            new GroupsConfiguration({
              hideSearch: true,
            })
          }
          messagesConfiguration={
            new MessagesConfiguration({
              disableTyping: true,
              hideMessageHeader: true,
            })
          }
        />
      );
    };

    export default GroupsWithMessagesDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupsWithMessagesDemo.jsx

    ```javascript theme={null}
    import {
      CometChatGroupsWithMessages,
      GroupsConfiguration,
      MessagesConfiguration,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupsWithMessagesDemo = () => {
      return (
        <CometChatGroupsWithMessages
          groupsConfiguration={
            new GroupsConfiguration({
              hideSearch: true,
            })
          }
          messagesConfiguration={
            new MessagesConfiguration({
              disableTyping: true,
              hideMessageHeader: true,
            })
          }
        />
      );
    };

    export default GroupsWithMessagesDemo;
    ```
  </Tab>
</Tabs>

***

### Advanced

For advanced-level customization, you can set custom views to the component. This lets you tailor each aspect of the component to fit your exact needs and application aesthetics. You can create and define your own views, layouts, and UI elements and then incorporate those into the component.

By utilizing the [Configuration](#configurations) object of each component, you can apply advanced-level customizations to the GroupsWithMessages.

**Example**

<Tabs>
  <Tab title="TypeScript">
    GroupsWithMessagesDemo.tsx

    ```typescript theme={null}
    import {
      CometChatGroupsWithMessages,
      GroupsConfiguration,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupsWithMessagesDemo = () => {
      const getErrorStateView = () => {
        return (
          <div style={{ height: "100vh", width: "100vw" }}>
            <img
              src="image"
              alt="error icon"
              style={{
                height: "100px",
                width: "100px",
                marginTop: "250px",
                justifyContent: "center",
              }}
            ></img>
          </div>
        );
      };
      return (
        <CometChatGroupsWithMessages
          groupsConfiguration={
            new GroupsConfiguration({
              errorStateView: getErrorStateView(),
            })
          }
        />
      );
    };

    export default GroupsWithMessagesDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupsWithMessagesDemo.jsx

    ```javascript theme={null}
    import {
      CometChatGroupsWithMessages,
      GroupsConfiguration,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupsWithMessagesDemo = () => {
      const getErrorStateView = () => {
        return (
          <div style={{ height: "100vh", width: "100vw" }}>
            <img
              src="image"
              alt="error icon"
              style={{
                height: "100px",
                width: "100px",
                marginTop: "250px",
                justifyContent: "center",
              }}
            ></img>
          </div>
        );
      };
      return (
        <CometChatGroupsWithMessages
          groupsConfiguration={
            new GroupsConfiguration({
              errorStateView: getErrorStateView(),
            })
          }
        />
      );
    };

    export default GroupsWithMessagesDemo;
    ```
  </Tab>
</Tabs>

***

To find all the details on individual Component advance customization you can refer, [Groups Advance](/ui-kit/react/v4/groups#customization) and [Messages Advance](/ui-kit/react/v4/messages#advanced).

GroupsWithMessages uses advanced-level customization of both Groups & Messages components to achieve its default behavior.

1. GroupsWithMessages utilizes the [onItemClick](/ui-kit/react/v4/groups#2-onitemclick) property of the `Groups` subcomponent to navigate the group from [Groups](/ui-kit/react/v4/groups) to [Messages](/ui-kit/react/v4/messages)

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/L67V-UjCgqzL1qxp/images/74a441ba-groups_with_messages_onitemclick_web_screens-1d1519011941cfe7498682d4a010cbe3.png?fit=max&auto=format&n=L67V-UjCgqzL1qxp&q=85&s=6365308e1d1fd560e5d94ee375d1c646" width="3600" height="2400" data-path="images/74a441ba-groups_with_messages_onitemclick_web_screens-1d1519011941cfe7498682d4a010cbe3.png" />
</Frame>

2. GroupsWithMessages utilizes the [menus](/ui-kit/react/v4/messages#auxiliarymenu) of the `Messages` subcomponent to navigate from [Messages](/ui-kit/react/v4/messages) to [Details](/ui-kit/react/v4/group-details)

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/1W9AWrFs7khmFUQr/images/c4e87a0f-groups_with_messages_advance_menu_web_screens-4ece179204379ac4cfd2df668d1a34b8.png?fit=max&auto=format&n=1W9AWrFs7khmFUQr&q=85&s=c44126b415c7c722123cb21af3a193c4" width="3600" height="2400" data-path="images/c4e87a0f-groups_with_messages_advance_menu_web_screens-4ece179204379ac4cfd2df668d1a34b8.png" />
</Frame>

<Warning>
  When you override `onItemClick` and `menus`, the default behavior of GroupsWithMessages will also be overridden.
</Warning>

## Configurations

[Configurations](/ui-kit/react/v4/components-overview#configurations) offer the ability to customize the properties of each component within a Composite Component.

GroupsWithMessages has `Groups` and `Messages` component. Hence, each of these components will have its individual \`Configuration\`\`.

* `Configurations` expose properties that are available in its individual components.

#### Groups

You can customize the properties of the Groups component by making use of the `groupsConfiguration`. You can accomplish this by employing the `groupsConfiguration` props as demonstrated below:

<Tabs>
  <Tab title="TypeScript">
    ```typescript theme={null}
     groupsConfiguration={new GroupsConfiguration({
      //override properties of groups
      })}
    ```
  </Tab>

  <Tab title="JavaScript">
    ```javascript theme={null}
     groupsConfiguration={new GroupsConfiguration({
      //override properties of groups
      })}
    ```
  </Tab>
</Tabs>

All exposed properties of `GroupsConfiguration` can be found under [Groups](/ui-kit/react/v4/groups#functionality). Properties marked with the [report]() symbol are not accessible within the Configuration Object.

**Example**

Let's say you want to change the style of the Groups subcomponent and, in addition, you only want to display the Group List based on only joined groups and setting the limit to 3.

You can modify the style using the `groupsStyle` property and filter the list with the `groupsRequestBuilder` property.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/sVDw7GNAn28WGWte/images/4ba14c84-groups_with_messages_groups_configuration_web_screens-98c1c713bbb8b2c0ffed6289501e2974.png?fit=max&auto=format&n=sVDw7GNAn28WGWte&q=85&s=944a5cd7493cf756b2a94a719e4e2033" width="3600" height="2400" data-path="images/4ba14c84-groups_with_messages_groups_configuration_web_screens-98c1c713bbb8b2c0ffed6289501e2974.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    GroupsWithMessagesDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatGroupsWithMessages,
      GroupsConfiguration,
      GroupsStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupsWithMessagesDemo = () => {
      const groupsStyle = new GroupsStyle({
        width: "100%",
        height: "100%",
        border: "1px solid #ee7752",
        background: "linear-gradient(#ee7752, #e73c7e, #23a6d5, #23d5ab)",
      });
      return (
        <CometChatGroupsWithMessages
          groupsConfiguration={
            new GroupsConfiguration({
              groupsStyle: groupsStyle,
              groupsRequestBuilder: new CometChat.GroupsRequestBuilder()
                .setLimit(3)
                .joinedOnly(true),
            })
          }
        />
      );
    };

    export default GroupsWithMessagesDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupsWithMessagesDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatGroupsWithMessages,
      GroupsConfiguration,
      GroupsStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupsWithMessagesDemo = () => {
      const groupsStyle = new GroupsStyle({
        width: "100%",
        height: "100%",
        border: "1px solid #ee7752",
        background: "linear-gradient(#ee7752, #e73c7e, #23a6d5, #23d5ab)",
      });
      return (
        <CometChatGroupsWithMessages
          groupsConfiguration={
            new GroupsConfiguration({
              groupsStyle: groupsStyle,
              groupsRequestBuilder: new CometChat.GroupsRequestBuilder()
                .setLimit(3)
                .joinedOnly(true),
            })
          }
        />
      );
    };

    export default GroupsWithMessagesDemo;
    ```
  </Tab>
</Tabs>

***

#### Messages

You can customize the properties of the Messages component by making use of the messagesConfiguration. You can accomplish this by employing the `messagesConfiguration` props as demonstrated below:

<Tabs>
  <Tab title="TypeScript">
    ```typescript theme={null}
      messagesConfiguration={new MessagesConfiguration({
      //override properties of messages
      })}
    ```
  </Tab>

  <Tab title="JavaScript">
    ```javascript theme={null}
     messagesConfiguration={new MessagesConfiguration({
      //override properties of messages
      })}
    ```
  </Tab>
</Tabs>

All exposed properties of `MessagesConfiguration` can be found under [Messages](/ui-kit/react/v4/messages#functionality). Properties marked with the [report]() symbol are not accessible within the Configuration Object.

**Example**

Let's say you want to change the style of the Messages subcomponent and, in addition, you only want to hide message header.

You can modify the style using the `messagesStyle` property and hide the message header with the `hideMessageHeader` property.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/dDWpooIQ48haNjyU/images/75a406dd-groups_with_messages_messages_configuration_web_screens-b3421e9b740b79d9e0f9495fc0278efe.png?fit=max&auto=format&n=dDWpooIQ48haNjyU&q=85&s=2689955768847da22e62a5f732d95df3" width="3600" height="2400" data-path="images/75a406dd-groups_with_messages_messages_configuration_web_screens-b3421e9b740b79d9e0f9495fc0278efe.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    GroupsWithMessagesDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatGroupsWithMessages,
      MessagesConfiguration,
      MessagesStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupsWithMessagesDemo = () => {
      const messagesStyle = new MessagesStyle({
        width: "100%",
        height: "100%",
        border: "1px solid #ee7752",
        background: "linear-gradient(#ee7752, #e73c7e, #23a6d5, #23d5ab)",
        messageTextColor: "yellow",
      });
      return (
        <CometChatGroupsWithMessages
          messagesConfiguration={
            new MessagesConfiguration({
              hideMessageHeader: true,
              messagesStyle: messagesStyle,
            })
          }
        />
      );
    };

    export default GroupsWithMessagesDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupsWithMessagesDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatGroupsWithMessages,
      MessagesConfiguration,
      MessagesStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupsWithMessagesDemo = () => {
      const messagesStyle = new MessagesStyle({
        width: "100%",
        height: "100%",
        border: "1px solid #ee7752",
        background: "linear-gradient(#ee7752, #e73c7e, #23a6d5, #23d5ab)",
        messageTextColor: "yellow",
      });
      return (
        <CometChatGroupsWithMessages
          messagesConfiguration={
            new MessagesConfiguration({
              hideMessageHeader: true,
              messagesStyle: messagesStyle,
            })
          }
        />
      );
    };

    export default GroupsWithMessagesDemo;
    ```
  </Tab>
</Tabs>

***

#### Join Group

You can customize the properties of the Join Group component by making use of the JoinGroupConfiguration. You can accomplish this by employing the `joinGroupConfiguration` props as demonstrated below:

<Tabs>
  <Tab title="TypeScript">
    ```typescript theme={null}
      joinGroupConfiguration={new JoinGroupConfiguration({
      //override properties of join group
      })}
    ```
  </Tab>

  <Tab title="JavaScript">
    ```javascript theme={null}
     joinGroupConfiguration={new JoinGroupConfiguration({
      //override properties of join group
      })}
    ```
  </Tab>
</Tabs>

All exposed properties of `JoinGroupConfiguration` can be found under [Join Group](/ui-kit/react/v4/join-protected-group#functionality). Properties marked with the [report]() symbol are not accessible within the Configuration Object.

**Example**

Let's say you want to change the style of the Join Group subcomponent.

You can modify the style using the `joinGroupStyle` property.

<Tabs>
  <Tab title="TypeScript">
    GroupsWithMessagesDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatGroupsWithMessages,
      JoinGroupConfiguration,
      JoinGroupStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupsWithMessagesDemo = () => {
      const joinGroupStyle = new JoinGroupStyle({
        background: "#e2d6ff",
        joinButtonBackground: "#cb1fff",
        joinButtonTextColor: "#000000",
      });
      return (
        <CometChatGroupsWithMessages
          joinGroupConfiguration={
            new JoinGroupConfiguration({
              joinGroupStyle: joinGroupStyle,
            })
          }
        />
      );
    };

    export default GroupsWithMessagesDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupsWithMessagesDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatGroupsWithMessages,
      JoinGroupConfiguration,
      JoinGroupStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupsWithMessagesDemo = () => {
      const joinGroupStyle = new JoinGroupStyle({
        background: "#e2d6ff",
        joinButtonBackground: "#cb1fff",
        joinButtonTextColor: "#000000",
      });
      return (
        <CometChatGroupsWithMessages
          joinGroupConfiguration={
            new JoinGroupConfiguration({
              joinGroupStyle: joinGroupStyle,
            })
          }
        />
      );
    };

    export default GroupsWithMessagesDemo;
    ```
  </Tab>
</Tabs>

***

#### Create Group

You can customize the properties of the Create Group component by making use of the CreateGroupConfiguration. You can accomplish this by employing the `createGroupConfiguration` props as demonstrated below:

<Tabs>
  <Tab title="TypeScript">
    ```typescript theme={null}
      createGroupConfiguration={new CreateGroupConfiguration({
      //override properties of create group
      })}
    ```
  </Tab>

  <Tab title="JavaScript">
    ```javascript theme={null}
     createGroupConfiguration={new CreateGroupConfiguration({
      //override properties of create group
      })}
    ```
  </Tab>
</Tabs>

All exposed properties of `CreateGroupConfiguration` can be found under [Create Group](/ui-kit/react/v4/create-group#functionality). Properties marked with the [report]() symbol are not accessible within the Configuration Object.

**Example**

Let's say you want to change the style of the Create Group subcomponent.

You can modify the style using the `createGroupStyle` property.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/Q-VZaihy61fy3D_G/images/1ef8b8c0-groups_with_messages_create_group_configuration_web_screens-824cd5c668fd306b28694dcf64bab610.png?fit=max&auto=format&n=Q-VZaihy61fy3D_G&q=85&s=1b007695552c14498b01d1e9d85cb7c9" width="3600" height="2400" data-path="images/1ef8b8c0-groups_with_messages_create_group_configuration_web_screens-824cd5c668fd306b28694dcf64bab610.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    GroupsWithMessagesDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatGroupsWithMessages,
      CreateGroupConfiguration,
      CreateGroupStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupsWithMessagesDemo = () => {
      const createGroupStyle = new CreateGroupStyle({
        background: "#e6dcf7",
        activeGroupTypeBackground: "#7436e0",
        titleTextColor: "#ffffff",
        height: "500px",
        width: "500px",
      });
      return (
        <CometChatGroupsWithMessages
          createGroupConfiguration={
            new CreateGroupConfiguration({
              createGroupStyle: createGroupStyle,
            })
          }
        />
      );
    };

    export default GroupsWithMessagesDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupsWithMessagesDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatGroupsWithMessages,
      CreateGroupConfiguration,
      CreateGroupStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupsWithMessagesDemo = () => {
      const createGroupStyle = new CreateGroupStyle({
        background: "#e6dcf7",
        activeGroupTypeBackground: "#7436e0",
        titleTextColor: "#ffffff",
        height: "500px",
        width: "500px",
      });
      return (
        <CometChatGroupsWithMessages
          createGroupConfiguration={
            new CreateGroupConfiguration({
              createGroupStyle: createGroupStyle,
            })
          }
        />
      );
    };

    export default GroupsWithMessagesDemo;
    ```
  </Tab>
</Tabs>

***


> ## Documentation Index
> Fetch the complete documentation index at: https://www.cometchat.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Groups With Messages

> Groups With Messages — CometChat documentation.

## Overview

The GroupsWithMessages is a [Composite Component](/docs/ui-kit/angular/v4/components-overview#composite-components) encompassing components such as [Groups](/docs/ui-kit/angular/v4/groups) and [Messages](/docs/ui-kit/angular/v4/messages). Both of these component contributes to the functionality and structure of the overall GroupsWithMessages component.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/CrArf1QwUPg5EvCC/images/2c9552a8-groups_with_messages_overview_web_screens-6639575885906978e81df0cd11d3efde.png?fit=max&auto=format&n=CrArf1QwUPg5EvCC&q=85&s=2cf8701de19fdf341941cba73ea19a8a" width="3600" height="2400" data-path="images/2c9552a8-groups_with_messages_overview_web_screens-6639575885906978e81df0cd11d3efde.png" />
</Frame>

| Components                              | Description                                                                                                                    |
| --------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------ |
| [Groups](/docs/ui-kit/angular/v4/groups)     | The `Groups` component is designed to display a list of `Groups`. This essentially represents the recent conversation history. |
| [Messages](/docs/ui-kit/angular/v4/messages) | The `Messages` component is designed to manage the messaging interaction for `Group's` conversations.                          |

## Usage

### Integration

<Tabs>
  <Tab title="app.module.ts">
    ```ts theme={null}
    import { CUSTOM_ELEMENTS_SCHEMA, NgModule } from "@angular/core";
    import { BrowserModule } from "@angular/platform-browser";
    import { CometChatGroups } from "@cometchat/chat-uikit-angular";
    import { AppComponent } from "./app.component";

    @NgModule({
      imports: [BrowserModule, CometChatGroups],
      declarations: [AppComponent],
      providers: [],
      bootstrap: [AppComponent],
      schemas: [CUSTOM_ELEMENTS_SCHEMA],
    })
    export class AppModule {}
    ```
  </Tab>

  <Tab title="app.component.ts">
    ```ts theme={null}
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      title = 'angular-app';
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-groups-with-messages></cometchat-groups-with-messages>
    </div>
    ```
  </Tab>
</Tabs>

***

### Actions

[Actions](/docs/ui-kit/angular/v4/components-overview#actions) dictate how a component functions. They are divided into two types: Predefined and User-defined. You can override either type, allowing you to tailor the behavior of the component to fit your specific needs.

##### 1. onError

This action doesn't change the behavior of the component but rather listens for any errors that occur in the GroupsWithMessages component.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public handleOnError = (error: CometChat.CometChatException) => {
        console.log("your custom on error action", error);
      };
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-groups-with-messages
        [onError]="handleOnError"
      ></cometchat-groups-with-messages>
    </div>
    ```
  </Tab>
</Tabs>

The child components - [Groups](/docs/ui-kit/angular/v4/groups) and [Messages](/docs/ui-kit/angular/v4/messages) - both have their own set of action events.

The Action of the components can be overridden through the use of the [Configurations](#configurations) object of its components. Here is an example code snippet.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { MessagesConfiguration, MessageHeaderConfiguration, GroupsConfiguration } from '@cometchat/uikit-shared';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public handleOnItemClickGroup = (group: CometChat.Group)=> {
        console.log("your custom on item click action", group);
      };
      public handleOnBack = () => {
        console.log("Your custom on back action");
      };
      groupsConfiguration = new GroupsConfiguration({
        onItemClick: this.handleOnItemClickGroup
      });
      public messagesConfiguration = new MessagesConfiguration({
        messageHeaderConfiguration: new MessageHeaderConfiguration({
          onBack:this.handleOnBack
        })
      });
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-groups-with-messages
        [groupsConfiguration]="groupsConfiguration"
        [messagesConfiguration]="messagesConfiguration"
      ></cometchat-groups-with-messages>
    </div>
    ```
  </Tab>
</Tabs>

The GroupsWithMessages component overrides several actions from its components to reach its default behavior. The list of actions overridden by GroupsWithMessages includes:

* [OnItemClick](/docs/ui-kit/angular/v4/groups#2-onitemclick) : By overriding the `OnItemClick` of the Groups Component, GroupsWithMessages achieves navigation from [Groups](/docs/ui-kit/angular/v4/groups) to [Messages](/docs/ui-kit/angular/v4/messages) component.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/L67V-UjCgqzL1qxp/images/74a441ba-groups_with_messages_onitemclick_web_screens-1d1519011941cfe7498682d4a010cbe3.png?fit=max&auto=format&n=L67V-UjCgqzL1qxp&q=85&s=6365308e1d1fd560e5d94ee375d1c646" width="3600" height="2400" data-path="images/74a441ba-groups_with_messages_onitemclick_web_screens-1d1519011941cfe7498682d4a010cbe3.png" />
</Frame>

### Fliters

**Filters** allow you to customize the data displayed in a list within a Component. You can filter the list based on your specific criteria, allowing for a more customized. Filters can be applied using RequestBuilders of Chat SDK.

While the GroupsWithMessages component does not have filters, its components do, For more detail on individual filters of its component refer to [Groups Filters](/docs/ui-kit/angular/v4/groups#filters) and [Messages Filters](/docs/ui-kit/angular/v4/messages#filters).

By utilizing the [Configurations](#configurations) object of its components, you can apply filters.

In the following **example**, we are applying a filter to the Group List based on only joined groups and setting the limit to 3 using the `groupsRequestBuilder`.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { GroupsConfiguration } from '@cometchat/uikit-shared';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      groupsRequestBuilder = new CometChat.GroupsRequestBuilder().setLimit(4).joinedOnly(true);
      groupsConfiguration = new GroupsConfiguration({
        groupsRequestBuilder:this.groupsRequestBuilder
      });
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-groups-with-messages
        [groupsConfiguration]="groupsConfiguration"
      ></cometchat-groups-with-messages>
    </div>
    ```
  </Tab>
</Tabs>

***

### Events

[Events](/docs/ui-kit/angular/v4/components-overview#events) are emitted by a `Component`. By using event you can extend existing functionality. Being global events, they can be applied in Multiple Locations and are capable of being Added or Removed.

The GroupsWithMessages does not produce any events but its component does.

***

## Customization

To fit your app's design requirements, you have the ability to customize the appearance of the GroupsWithMessages component. We provide exposed methods that allow you to modify the experience and behavior according to your specific needs.

### Style

Using **Style** you can **customize** the look and feel of the component in your app, These parameters typically control elements such as the **color**, **size**, **shape**, and **fonts** used within the component.

##### 1. GroupsWithMessages Style

You can set the `groupsWithMessagesStyle` to the GroupsWithMessages Component to customize the styling.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/4xujL4pc0yDqaECl/images/d362dd5c-groups_with_messages_style_web_screens-02770b145161909851c36884ae4089b6.png?fit=max&auto=format&n=4xujL4pc0yDqaECl&q=85&s=e538c842f064a683ff414966beda51cf" width="3600" height="2400" data-path="images/d362dd5c-groups_with_messages_style_web_screens-02770b145161909851c36884ae4089b6.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { WithMessagesStyle } from '@cometchat/uikit-shared';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      groupsWithMessagesStyle = new WithMessagesStyle({
        background: "#e2d6ff",
        messageTextColor: "#000000",
        borderRadius: "12px",
      });
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-groups-with-messages
        [groupsWithMessagesStyle]="groupsWithMessagesStyle"
      ></cometchat-groups-with-messages>
    </div>
    ```
  </Tab>
</Tabs>

***

You can also customize its component styles. For more details on individual component styles, you can refer [Groups Styles](/docs/ui-kit/angular/v4/groups#1-groups-style) and [Messages Styles](/docs/ui-kit/angular/v4/messages#1-messages-style).

Styles can be applied to SubComponents using their respective [configurations](#configurations).

**Example**

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { MessagesConfiguration, MessagesStyle, GroupsStyle, GroupsConfiguration } from '@cometchat/uikit-shared';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      groupsStyle = new GroupsStyle({
        background: "#f7f2ff",
        titleTextColor: "#6414fa",
        searchTextColor: "#940be3",
        separatorColor: "#ffffff",
      });
      groupsConfiguration = new GroupsConfiguration({
        groupsStyle:this.groupsStyle
      });
      public messagesConfiguration = new MessagesConfiguration({
        messagesStyle: new MessagesStyle({
        width: "100%",
        height: "100%",
        border: "3px solid #cb1fff",
        background: "#f7f2ff",
        }),
      });
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-groups-with-messages
        [groupsConfiguration]="groupsConfiguration"
        [messagesConfiguration]="messagesConfiguration"
      ></cometchat-groups-with-messages>
    </div>
    ```
  </Tab>
</Tabs>

***

### Functionality

These are a set of **small functional customizations** that allow you to **fine-tune** the overall experience of the component. With these, you can **change text**, set **custom icons**, and toggle the **visibility** of UI elements.

you can utilize the `group` method with a [Group](/docs/sdk/javascript/create-group) object as input to the GroupsWithMessages component. This will automatically direct you to the [Messages](/docs/ui-kit/angular/v4/messages) component for the specified `Group`.

##### 1. Group

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { WithMessagesStyle } from '@cometchat/uikit-shared';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-groups-with-messages
        [group]="groupObject"
      ></cometchat-groups-with-messages>
    </div>
    ```
  </Tab>
</Tabs>

Below is a list of customizations along with corresponding code snippets:

| Property         | Description                                                                                                                                                      | Code                                         |
| ---------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------- | -------------------------------------------- |
| **isMobileView** | A boolean indicating if the component should render in mobile view for optimized display on mobile devices.                                                      | `[isMobileView]= "false"`                    |
| **group**        | Use the group property with a Group object as input for the GroupsWithMessages component to navigate directly to the Messages component for the specified Group. | `[group]="groupObject"`                      |
| **messageText**  | It represents the textual content which will be replaced with the messages component when user clicks on a particular group chat.                                | `[messageText]="'Your Custom Message Text'"` |

***

##### Components

Nearly all functionality customizations available for a Component are also available for the composite component. Using [Configuration](#configurations), you can modify the properties of its components to suit your needs.

You can find the list of all Functionality customization of individual components in [Groups](/docs/ui-kit/angular/v4/groups#functionality) and [Messages](/docs/ui-kit/angular/v4/messages#functionality).

**Example**

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { MessagesConfiguration, GroupsConfiguration } from '@cometchat/uikit-shared';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      groupsConfiguration = new GroupsConfiguration({
        hideSearch:true
      });
      public messagesConfiguration = new MessagesConfiguration({
        disableTyping: true,
        hideMessageHeader: true,
      });
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-groups-with-messages
        [groupsConfiguration]="groupsConfiguration"
        [messagesConfiguration]="messagesConfiguration"
      ></cometchat-groups-with-messages>
    </div>
    ```
  </Tab>
</Tabs>

***

### Advanced

For advanced-level customization, you can set custom views to the component. This lets you tailor each aspect of the component to fit your exact needs and application aesthetics. You can create and define your own views, layouts, and UI elements and then incorporate those into the component.

By utilizing the [Configuration](#configurations) object of each component, you can apply advanced-level customizations to the GroupsWithMessages.

**Example**

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { GroupsConfiguration } from '@cometchat/uikit-shared';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupsConfiguration!: GroupsConfiguration;
      @ViewChild('errorStateView', { static: true }) errorStateView!: TemplateRef<any>;
      ngOnInit(): void {
        this.groupsConfiguration = new GroupsConfiguration({
          errorStateView:this.errorStateView,
        });
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-groups-with-messages
        [groupsConfiguration]="groupsConfiguration"
      ></cometchat-groups-with-messages>
    </div>
    <ng-template #errorStateView>
      <div style="height: 100vh; width: 100vw">
        <img
          src="icon"
          alt="error icon"
          style="height:100px; width: 100px; justify-content: center; margin-top: 250px; margin-right: 700px;"
        />
      </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

To find all the details on individual Component advance customization you can refer, [Groups Advance](/docs/ui-kit/angular/v4/groups#customization) and [Messages Advance](/docs/ui-kit/angular/v4/messages#advanced).

GroupsWithMessages uses advanced-level customization of both Groups & Messages components to achieve its default behavior.

1. GroupsWithMessages utilizes the [onItemClick](/docs/ui-kit/angular/v4/groups#2-onitemclick) property of the `Groups` subcomponent to navigate the group from [Groups](/docs/ui-kit/angular/v4/groups) to [Messages](/docs/ui-kit/angular/v4/messages)

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/L67V-UjCgqzL1qxp/images/74a441ba-groups_with_messages_onitemclick_web_screens-1d1519011941cfe7498682d4a010cbe3.png?fit=max&auto=format&n=L67V-UjCgqzL1qxp&q=85&s=6365308e1d1fd560e5d94ee375d1c646" width="3600" height="2400" data-path="images/74a441ba-groups_with_messages_onitemclick_web_screens-1d1519011941cfe7498682d4a010cbe3.png" />
</Frame>

2. GroupsWithMessages utilizes the [menus](/docs/ui-kit/angular/v4/messages#auxiliarymenu) of the `Messages` subcomponent to navigate from [Messages](/docs/ui-kit/angular/v4/messages) to [Details](/docs/ui-kit/angular/v4/group-details)

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/1W9AWrFs7khmFUQr/images/c4e87a0f-groups_with_messages_advance_menu_web_screens-4ece179204379ac4cfd2df668d1a34b8.png?fit=max&auto=format&n=1W9AWrFs7khmFUQr&q=85&s=c44126b415c7c722123cb21af3a193c4" width="3600" height="2400" data-path="images/c4e87a0f-groups_with_messages_advance_menu_web_screens-4ece179204379ac4cfd2df668d1a34b8.png" />
</Frame>

<Warning>
  When you override `onItemClick` and `menus`, the default behavior of GroupsWithMessages will also be overridden.
</Warning>

## Configurations

[Configurations](/docs/ui-kit/angular/v4/components-overview#configurations) offer the ability to customize the properties of each component within a Composite Component.

GroupsWithMessages has `Groups` and `Messages` component. Hence, each of these components will have its individual \`Configuration\`\`.

* `Configurations` expose properties that are available in its individual components.

#### Groups

You can customize the properties of the Groups component by making use of the `groupsConfiguration`.

All exposed properties of `GroupsConfiguration` can be found under [Groups](/docs/ui-kit/angular/v4/groups#functionality). Properties marked with the 🛑 symbol are not accessible within the Configuration Object.

**Example**

Let's say you want to change the style of the Groups subcomponent and, in addition, you only want to display the Group List based on only joined groups and setting the limit to 3.

You can modify the style using the `groupsStyle` property and filter the list with the `groupsRequestBuilder` property.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/sVDw7GNAn28WGWte/images/4ba14c84-groups_with_messages_groups_configuration_web_screens-98c1c713bbb8b2c0ffed6289501e2974.png?fit=max&auto=format&n=sVDw7GNAn28WGWte&q=85&s=944a5cd7493cf756b2a94a719e4e2033" width="3600" height="2400" data-path="images/4ba14c84-groups_with_messages_groups_configuration_web_screens-98c1c713bbb8b2c0ffed6289501e2974.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { GroupsStyle, GroupsConfiguration } from '@cometchat/uikit-shared';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupsConfiguration!: GroupsConfiguration;
      groupsRequestBuilder = new CometChat.GroupsRequestBuilder().setLimit(3).joinedOnly(true)
      groupsStyle = new GroupsStyle({
        background: "#f7f2ff",
        titleTextColor: "#6414fa",
        searchTextColor: "#940be3",
        separatorColor: "#ffffff",
      });
      ngOnInit(): void {
        this.groupsConfiguration = new GroupsConfiguration({
          groupsRequestBuilder:this.groupsRequestBuilder,
          groupsStyle:this.groupsStyle,
        });
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-groups-with-messages
        [groupsConfiguration]="groupsConfiguration"
      ></cometchat-groups-with-messages>
    </div>
    ```
  </Tab>
</Tabs>

All exposed properties of `MessagesConfiguration` can be found under [Messages](/docs/ui-kit/angular/v4/messages#functionality). Properties marked with the 🛑 symbol are not accessible within the Configuration Object.

**Example**

Let's say you want to change the style of the Messages subcomponent and, in addition, you only want to hide message header.

You can modify the style using the `messagesStyle` property and hide the message header with the `hideMessageHeader` property.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/dDWpooIQ48haNjyU/images/75a406dd-groups_with_messages_messages_configuration_web_screens-b3421e9b740b79d9e0f9495fc0278efe.png?fit=max&auto=format&n=dDWpooIQ48haNjyU&q=85&s=2689955768847da22e62a5f732d95df3" width="3600" height="2400" data-path="images/75a406dd-groups_with_messages_messages_configuration_web_screens-b3421e9b740b79d9e0f9495fc0278efe.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { MessagesStyle, MessagesConfiguration } from '@cometchat/uikit-shared';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public messagesConfiguration = new MessagesConfiguration({
        hideMessageHeader: true,
        messagesStyle: new MessagesStyle({
        width: "100%",
        height: "100%",
        border: "3px solid #cb1fff",
        background: "linear-gradient(#885df5, #d396ff, #e497f0, #dd20fa)",
        }),
      });
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-groups-with-messages
        [messagesConfiguration]="messagesConfiguration"
      ></cometchat-groups-with-messages>
    </div>
    ```
  </Tab>
</Tabs>

***

#### Join Group

You can customize the properties of the Join Group component by making use of the JoinGroupConfiguration. You can accomplish this by employing the `joinGroupConfiguration` props as demonstrated below:

All exposed properties of `JoinGroupConfiguration` can be found under [Join Group](/docs/ui-kit/angular/v4/join-protected-group#functionality). Properties marked with the 🛑 symbol are not accessible within the Configuration Object.

**Example**

Let's say you want to change the style of the Join Group subcomponent.

You can modify the style using the `joinGroupStyle` property.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, JoinGroupStyle } from '@cometchat/chat-uikit-angular';
    import { JoinGroupConfiguration } from '@cometchat/uikit-shared';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      joinGroupConfiguration = new JoinGroupConfiguration({
        joinGroupStyle: new JoinGroupStyle({
          background: "#e2d6ff",
          joinButtonBackground: "#cb1fff",
          joinButtonTextColor: "#000000",
        })
      });
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-groups-with-messages
        [joinGroupConfiguration]="joinGroupConfiguration"
      ></cometchat-groups-with-messages>
    </div>
    ```
  </Tab>
</Tabs>

***

#### Create Group

You can customize the properties of the Create Group component by making use of the CreateGroupConfiguration. You can accomplish this by employing the `createGroupConfiguration` props as demonstrated below:

All exposed properties of `CreateGroupConfiguration` can be found under [Create Group](/docs/ui-kit/angular/v4/create-group#functionality). Properties marked with the 🛑 symbol are not accessible within the Configuration Object.

**Example**

Let's say you want to change the style of the Create Group subcomponent.

You can modify the style using the `createGroupStyle` property.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/Q-VZaihy61fy3D_G/images/1ef8b8c0-groups_with_messages_create_group_configuration_web_screens-824cd5c668fd306b28694dcf64bab610.png?fit=max&auto=format&n=Q-VZaihy61fy3D_G&q=85&s=1b007695552c14498b01d1e9d85cb7c9" width="3600" height="2400" data-path="images/1ef8b8c0-groups_with_messages_create_group_configuration_web_screens-824cd5c668fd306b28694dcf64bab610.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, CreateGroupStyle } from '@cometchat/chat-uikit-angular';
    import { CreateGroupConfiguration } from '@cometchat/uikit-shared';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      createGroupConfiguration = new CreateGroupConfiguration({
        createGroupStyle: new CreateGroupStyle({
          background: "#e6dcf7",
          activeGroupTypeBackground: "#7436e0",
          titleTextColor: "#ffffff",
          height: "500px",
          width: "500px",
        })
      });
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-groups-with-messages
        [createGroupConfiguration]="createGroupConfiguration"
      ></cometchat-groups-with-messages>
    </div>
    ```
  </Tab>
</Tabs>
